Index: branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 766)
@@ -85,9 +85,5 @@
   ("OutputBitDepthC,d", m_outputBitDepthC, 0, "bit depth of YUV output chroma component (default: use 0 for native depth)")
 #if H_MV
-#if H_MV_6_HRD_O0217_13
   ("TargetOptLayerSetIdx,x", m_targetOptLayerSetIdx, -1, "Target output layer set index. (default: -1, determine automatically to be equal to highest layer set index") // Should actually equal to 0 as default. However, this would cause only the base layer to be decoded.  
-#else
-  ("MaxLayerId,-ls", m_maxLayerId, MAX_NUM_LAYER_IDS-1, "Maximum LayerId to be decoded.")
-#endif
 #endif
   ("MaxTemporalLayer,t", m_iMaxTemporalLayer, -1, "Maximum Temporal Layer to be decoded. -1 to decode all layers")
@@ -128,7 +124,5 @@
   if ( !cfg_TargetDecLayerIdSetFile.empty() )
   {
-#if H_MV_6_HRD_O0217_13
     m_targetDecLayerIdSetFileEmpty = false;     
-#endif
     FILE* targetDecLayerIdSetFile = fopen ( cfg_TargetDecLayerIdSetFile.c_str(), "r" );
     if ( targetDecLayerIdSetFile )
@@ -174,15 +168,5 @@
   }
 #if H_MV
-#if H_MV_6_HRD_O0217_13
   m_targetDecLayerIdSet.push_back( 0 );         // Only base layer at startup
-#else
-  else
-  {
-    for ( Int curLayerId = 0; curLayerId <= m_maxLayerId; curLayerId++ )
-    {
-      m_targetDecLayerIdSet.push_back( curLayerId );
-    }
-  }
-#endif
 #endif
 
Index: branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.h	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.h	(revision 766)
@@ -59,7 +59,5 @@
   Char*         m_pchBitstreamFile;                   ///< input bitstream file name
 #if H_MV
-#if H_MV_6_HRD_O0217_13
   Int           m_targetOptLayerSetIdx;               ///< target output layer set index
-#endif
   Int           m_maxLayerId;                         ///< maximum nuh_layer_id decoded
   std::vector<Char*> m_pchReconFiles;                 ///< array of output reconstruction file name create from output reconstruction file name
@@ -77,7 +75,5 @@
 
   std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
-#if H_MV_6_HRD_O0217_13
   Bool          m_targetDecLayerIdSetFileEmpty;      ///< indication if target layers are given by file
-#endif
   Int           m_respectDefDispWindow;               ///< Only output content inside the default display window 
 
@@ -89,7 +85,4 @@
   : m_pchBitstreamFile(NULL)
 #if H_MV
-#if !H_MV_6_HRD_O0217_13
-  , m_maxLayerId(0)
-#endif
 #endif
   , m_pchReconFile(NULL)
@@ -99,7 +92,5 @@
   , m_iMaxTemporalLayer(-1)
   , m_decodedPictureHashSEIEnabled(0)
-#if H_MV_6_HRD_O0217_13
   , m_targetDecLayerIdSetFileEmpty(true)
-#endif
   , m_respectDefDispWindow(0)
   {}
Index: branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 766)
@@ -61,5 +61,4 @@
 {
 #if H_MV
-#if H_MV_LAYER_WISE_STARTUP
   for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++) 
   {
@@ -67,7 +66,4 @@
     m_layerInitilizedFlags[i] = false; 
   }
-#else
-  for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++) m_layerIdToDecIdx[i] = -1; 
-#endif
 #endif
 #if H_3D
@@ -192,7 +188,5 @@
     Bool newSliceDiffPoc   = false;
     Bool newSliceDiffLayer = false;
-#if H_MV_FIX_SKIP_PICTURES
     Bool sliceSkippedFlag = false; 
-#endif
 #if H_3D
     Bool allLayersDecoded  = false;     
@@ -212,32 +206,17 @@
       read(nalu, nalUnit);
 #if H_MV      
-#if !H_MV_6_HRD_O0217_13
-      Int decIdx     = xGetDecoderIdx( nalu.m_layerId , true );
-#endif
-#if H_MV_6_LAYER_ID_32
       if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu) || nalu.m_layerId > MAX_NUM_LAYER_IDS-1 ) 
-#else            
-      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu) )
-#endif
       {
         bNewPicture = false;
-#if H_MV_6_LAYER_ID_32
         if ( !bitstreamFile )
         {
           decIdxLastPic     = decIdxCurrPic; 
         }
-#endif
       }
       else
       { 
-#if H_MV_6_HRD_O0217_13
         Int decIdx     = xGetDecoderIdx( nalu.m_layerId , true );      
-#endif
         newSliceDiffLayer = nalu.isSlice() && ( nalu.m_layerId != layerIdCurrPic ) && !firstSlice;
-#if H_MV_FIX_SKIP_PICTURES
         newSliceDiffPoc   = m_tDecTop[decIdx]->decode(nalu, m_iSkipFrame, m_pocLastDisplay[decIdx], newSliceDiffLayer, sliceSkippedFlag );
-#else
-        newSliceDiffPoc   = m_tDecTop[decIdx]->decode(nalu, m_iSkipFrame, m_pocLastDisplay[decIdx], newSliceDiffLayer );
-#endif
         // decode function only returns true when all of the following conditions are true
         // - poc in particular layer changes
@@ -245,5 +224,4 @@
         // - nalu.isSlice() == true      
 
-#if H_MV_6_HRD_O0217_13
         // Update TargetDecLayerIdList only when not specified by layer id file, specification by file might actually out of conformance. 
         if (nalu.m_nalUnitType == NAL_UNIT_VPS && m_targetDecLayerIdSetFileEmpty )
@@ -258,13 +236,6 @@
           m_targetDecLayerIdSet = vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
         }
-#endif
-#if H_MV_FIX_SKIP_PICTURES
         bNewPicture       = ( newSliceDiffLayer || newSliceDiffPoc ) && !sliceSkippedFlag; 
         if ( nalu.isSlice() && firstSlice && !sliceSkippedFlag )        
-#else
-        bNewPicture       = newSliceDiffLayer || newSliceDiffPoc; 
-
-        if ( nalu.isSlice() && firstSlice )
-#endif
         {
           layerIdCurrPic = nalu.m_layerId; 
@@ -881,10 +852,8 @@
   Int decIdx = -1; 
 
-#if H_MV_6_LAYER_ID_32
   if ( layerId > MAX_NUM_LAYER_IDS-1 )  
   {
     return decIdx; 
   }
-#endif
 
   if ( m_layerIdToDecIdx[ layerId ] != -1 ) 
@@ -906,7 +875,5 @@
     m_tDecTop[ decIdx ]->setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
     m_tDecTop[ decIdx ]->setIvPicLists( &m_ivPicLists ); 
-#if H_MV_LAYER_WISE_STARTUP
     m_tDecTop[ decIdx ]->setLayerInitilizedFlags( m_layerInitilizedFlags );
-#endif
 
 #if H_3D
Index: branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecTop.h	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecTop.h	(revision 766)
@@ -67,7 +67,5 @@
   Int                             m_numDecoders;                               ///< number of decoder instances
   TComPicLists                    m_ivPicLists;                                ///< picture buffers of decoder instances
-#if H_MV_LAYER_WISE_STARTUP
   Bool                            m_layerInitilizedFlags[ MAX_NUM_LAYER_IDS ]; ///< for layerwise startup 
-#endif
 
 #else
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 766)
@@ -388,9 +388,5 @@
   ("VpsNumLayerSets",       m_vpsNumLayerSets    , 1                    , "Number of layer sets")    
   ("LayerIdsInSet_%d",      m_layerIdsInSets     , std::vector<Int>(1,0), MAX_VPS_OP_SETS_PLUS1 ,"LayerIds of Layer set")  
-#if H_MV_6_PS_0109_25
   ("DefaultOneTargetOutputLayerFlag"  , m_defaultOneTargetOutputLayerIdc  , 0, "Output highest layer of layer sets by default")
-#else
-  ("DefaultOneTargetOutputLayerFlag", m_defaultOneTargetOutputLayerFlag,  false , "Output highest layer of layer sets by default")      
-#endif
   ("OutputLayerSetIdx",     m_outputLayerSetIdx  , std::vector<Int>(0,0), "Indices of layer sets used as additional output layer sets")  
   ("LayerIdsInAddOutputLayerSet_%d", m_layerIdsInAddOutputLayerSet      , std::vector<Int>(1,0), MAX_VPS_ADD_OUTPUT_LAYER_SETS, "LayerIds of additional output layers")  
@@ -450,9 +446,5 @@
   
   // Coding structure parameters
-#if H_MV_LAYER_WISE_STARTUP
   ("IntraPeriod,-ip",         m_iIntraPeriod,std::vector<Int>(1,-1), "Intra period in frames, (-1: only first frame), per layer")
-#else
-  ("IntraPeriod,-ip",         m_iIntraPeriod,              -1, "Intra period in frames, (-1: only first frame)")
-#endif
   ("DecodingRefreshType,-dr", m_iDecodingRefreshType,       0, "Intra refresh type (0:none 1:CRA 2:IDR)")
   ("GOPSize,g",               m_iGOPSize,                   1, "GOP size of temporal structure")
@@ -626,14 +618,10 @@
 #if H_MV
 
-#if H_MV_6_HRD_O0217_13
   // DBP Size
   ("SubLayerFlagInfoPresentFlag",  m_subLayerFlagInfoPresentFlag , false                                           , "SubLayerFlagInfoPresentFlag")
-#endif
   // VPS VUI
   ("VpsVuiPresentFlag"           , m_vpsVuiPresentFlag           , false                                           , "VpsVuiPresentFlag           ")
-#if H_MV_6_PS_O0223_29
   ("CrossLayerPicTypeAlignedFlag", m_crossLayerPicTypeAlignedFlag, false                                           , "CrossLayerPicTypeAlignedFlag")  // Could actually be derived by the encoder
   ("CrossLayerIrapAlignedFlag"   , m_crossLayerIrapAlignedFlag   , false                                           , "CrossLayerIrapAlignedFlag   ")  // Could actually be derived by the encoder
-#endif
   ("BitRatePresentVpsFlag"       , m_bitRatePresentVpsFlag       , false                                           , "BitRatePresentVpsFlag       ")
   ("PicRatePresentVpsFlag"       , m_picRatePresentVpsFlag       , false                                           , "PicRatePresentVpsFlag       ")
@@ -644,5 +632,4 @@
   ("ConstantPicRateIdc"          , m_constantPicRateIdc          , std::vector< Int  >(1,0)  ,MAX_VPS_OP_SETS_PLUS1, "ConstantPicRateIdc per sub layer for the N-th layer set")
   ("AvgPicRate"                  , m_avgPicRate                  , std::vector< Int  >(1,0)  ,MAX_VPS_OP_SETS_PLUS1, "AvgPicRate         per sub layer for the N-th layer set")
-#if H_MV_6_O0226_37
   ("TilesNotInUseFlag"            , m_tilesNotInUseFlag            , true                                          , "TilesNotInUseFlag            ")
   ("TilesInUseFlag"               , m_tilesInUseFlag               , std::vector< Bool >(1,false)                   , "TilesInUseFlag               ")
@@ -650,5 +637,4 @@
   ("WppNotInUseFlag"              , m_wppNotInUseFlag              , true                                          , "WppNotInUseFlag              ")
   ("WppInUseFlag"                 , m_wppInUseFlag                 , std::vector< Bool >(1,0)                      , "WppInUseFlag                 ")
-#endif
   ("TileBoundariesAlignedFlag"   , m_tileBoundariesAlignedFlag   , std::vector< Bool >(1,0)  ,MAX_NUM_LAYERS       , "TileBoundariesAlignedFlag    per direct reference for the N-th layer")
   ("IlpRestrictedRefLayersFlag"  , m_ilpRestrictedRefLayersFlag  , false                                           , "IlpRestrictedRefLayersFlag")
@@ -1063,12 +1049,8 @@
   xResizeVector( m_bLoopFilterDisable ); 
   xResizeVector( m_bUseSAO ); 
-#if H_MV_LAYER_WISE_STARTUP
   xResizeVector( m_iIntraPeriod ); 
-#endif
-#if H_MV_6_O0226_37
   xResizeVector( m_tilesInUseFlag ); 
   xResizeVector( m_loopFilterNotAcrossTilesFlag ); 
   xResizeVector( m_wppInUseFlag ); 
-#endif
 #else
   m_aidQP = new Int[ m_framesToBeEncoded + m_iGOPSize + 1 ];
@@ -1415,9 +1397,5 @@
     for ( Int i = 0; i < m_layerIdsInSets[lsIdx].size(); i++ )
     {
-#if H_MV_6_LAYER_ID_32
       xConfirmPara( m_layerIdsInSets[lsIdx][i] < 0 || m_layerIdsInSets[lsIdx].size() >= MAX_NUM_LAYER_IDS, "LayerIdsInSet must be greater than and less than MAX_NUM_LAYER_IDS" ); 
-#else
-      xConfirmPara( m_layerIdsInSets[lsIdx][i] < 0 || m_layerIdsInSets[lsIdx].size() >= MAX_NUM_LAYER_IDS, "LayerIdsInSet must be greater than and less than 64" ); 
-#endif
     }
   }
@@ -1445,7 +1423,5 @@
   }
 
-#if H_MV_6_PS_0109_25
   xConfirmPara( m_defaultOneTargetOutputLayerIdc < 0 || m_defaultOneTargetOutputLayerIdc > 1, "Default one target output layer idc must be equal to 0 or equal to 1" );
-#endif
   xConfirmPara( m_profileLevelTierIdx.size() < m_vpsNumLayerSets + m_outputLayerSetIdx.size(), "The number of Profile Level Tier indices must be equal to the number of layer set plus the number of output layer set indices" );
 
@@ -1464,12 +1440,8 @@
   xConfirmPara( m_iGOPSize < 1 ,                                                            "GOP Size must be greater or equal to 1" );
   xConfirmPara( m_iGOPSize > 1 &&  m_iGOPSize % 2,                                          "GOP Size must be a multiple of 2, if GOP Size is greater than 1" );
-#if H_MV_LAYER_WISE_STARTUP
   for( Int layer = 0; layer < m_numberOfLayers; layer++ )
   {
     xConfirmPara( (m_iIntraPeriod[layer] > 0 && m_iIntraPeriod[layer] < m_iGOPSize) || m_iIntraPeriod[layer] == 0, "Intra period must be more than GOP size, or -1 , not 0" );
   }
-#else
-  xConfirmPara( (m_iIntraPeriod > 0 && m_iIntraPeriod < m_iGOPSize) || m_iIntraPeriod == 0, "Intra period must be more than GOP size, or -1 , not 0" );
-#endif
   xConfirmPara( m_iDecodingRefreshType < 0 || m_iDecodingRefreshType > 2,                   "Decoding Refresh Type must be equal to 0, 1 or 2" );
 #if H_MV
@@ -1497,12 +1469,8 @@
   if (m_iDecodingRefreshType == 2)
   {
-#if H_MV_LAYER_WISE_STARTUP
     for (Int i = 0; i < m_numberOfLayers; i++ )
     {
       xConfirmPara( m_iIntraPeriod[i] > 0 && m_iIntraPeriod[i] <= m_iGOPSize ,                      "Intra period must be larger than GOP size for periodic IDR pictures");
     }
-#else
-    xConfirmPara( m_iIntraPeriod > 0 && m_iIntraPeriod <= m_iGOPSize ,                      "Intra period must be larger than GOP size for periodic IDR pictures");
-#endif
   }
   xConfirmPara( (m_uiMaxCUWidth  >> m_uiMaxCUDepth) < 4,                                    "Minimum partition width size should be larger than or equal to 8");
@@ -1763,9 +1731,5 @@
   /* if this is an intra-only sequence, ie IntraPeriod=1, don't verify the GOP structure
    * This permits the ability to omit a GOP structure specification */
-#if H_MV_LAYER_WISE_STARTUP
   if (m_iIntraPeriod[layer] == 1 && m_GOPList[0].m_POC == -1) {
-#else
-  if (m_iIntraPeriod == 1 && m_GOPList[0].m_POC == -1) {
-#endif
     m_GOPList[0] = GOPEntry();
     m_GOPList[0].m_QPFactor = 1;
@@ -1792,9 +1756,5 @@
   }
   Int numOK=0;
-#if H_MV_LAYER_WISE_STARTUP
   xConfirmPara( m_iIntraPeriod[layer] >=0&&(m_iIntraPeriod[layer]%m_iGOPSize!=0), "Intra period must be a multiple of GOPSize, or -1" ); 
-#else
-  xConfirmPara( m_iIntraPeriod >=0&&(m_iIntraPeriod%m_iGOPSize!=0), "Intra period must be a multiple of GOPSize, or -1" );
-#endif
 
   for(Int i=0; i<m_iGOPSize; i++)
@@ -1807,9 +1767,5 @@
   
 #if H_MV
-#if H_MV_LAYER_WISE_STARTUP
   if ( (m_iIntraPeriod[layer] != 1) && !m_loopFilterOffsetInPPS && m_DeblockingFilterControlPresent && (!m_bLoopFilterDisable[layer]) )
-#else
-  if ( (m_iIntraPeriod != 1) && !m_loopFilterOffsetInPPS && m_DeblockingFilterControlPresent && (!m_bLoopFilterDisable[layer]) )
-#endif
 #else
   if ( (m_iIntraPeriod != 1) && !m_loopFilterOffsetInPPS && m_DeblockingFilterControlPresent && (!m_bLoopFilterDisable) )
@@ -2336,9 +2292,5 @@
   printf("Min PCM size                 : %d\n", 1 << m_uiPCMLog2MinSize);
   printf("Motion search range          : %d\n", m_iSearchRange );
-#if H_MV_LAYER_WISE_STARTUP
   xPrintParaVector( "Intra period", m_iIntraPeriod );
-#else
-  printf("Intra period                 : %d\n", m_iIntraPeriod );
-#endif
   printf("Decoding refresh type        : %d\n", m_iDecodingRefreshType );
 #if !H_MV
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 766)
@@ -89,9 +89,5 @@
   Int                    m_vpsNumLayerSets;                   ///< Number of layer sets
   std::vector< std::vector<Int> > m_layerIdsInSets;           ///< LayerIds in vps of layer set 
-#if H_MV_6_PS_0109_25
   Int                    m_defaultOneTargetOutputLayerIdc;    ///< Output highest layer of layer sets by default when equal to 1
-#else
-  Bool                   m_defaultOneTargetOutputLayerFlag;   ///< Output highest layer of layer sets by default  
-#endif
   std::vector<Int>       m_outputLayerSetIdx;                 ///< Indices of layer sets used as additional output layer sets  
   std::vector< std::vector<Int> > m_layerIdsInAddOutputLayerSet; ///< LayerIds in vps of additional output layers
@@ -102,15 +98,11 @@
   std::vector< std::vector<Int> > m_dependencyTypes;          ///< Dependency types of direct reference layers
 
-#if H_MV_6_HRD_O0217_13
   // DBP Size
   Bool m_subLayerFlagInfoPresentFlag;
-#endif
 
   // VPS VUI
   Bool m_vpsVuiPresentFlag;
-#if H_MV_6_PS_O0223_29
   Bool m_crossLayerPicTypeAlignedFlag;
   Bool m_crossLayerIrapAlignedFlag;
-#endif
   Bool m_bitRatePresentVpsFlag;
   Bool m_picRatePresentVpsFlag;
@@ -121,5 +113,4 @@
   std::vector< std::vector<Int  > > m_constantPicRateIdc;
   std::vector< std::vector<Int  > > m_avgPicRate;
-#if H_MV_6_O0226_37
   Bool                              m_tilesNotInUseFlag; 
   std::vector< Bool >               m_tilesInUseFlag;
@@ -128,5 +119,4 @@
   std::vector< Bool >               m_wppInUseFlag;
 
-#endif
   std::vector< std::vector<Bool > > m_tileBoundariesAlignedFlag;  
   Bool m_ilpRestrictedRefLayersFlag;
@@ -188,9 +178,5 @@
   
   // coding structure
-#if H_MV_LAYER_WISE_STARTUP
   std::vector<Int> m_iIntraPeriod;                            ///< period of I-slice (random access period)
-#else
-  Int       m_iIntraPeriod;                                   ///< period of I-slice (random access period)
-#endif
   Int       m_iDecodingRefreshType;                           ///< random access type
   Int       m_iGOPSize;                                       ///< GOP size of hierarchical structure
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 766)
@@ -235,9 +235,5 @@
   
   //====== Coding Structure ========
-#if H_MV_LAYER_WISE_STARTUP
   m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod[ layerIdInVps ] );
-#else
-  m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod );
-#endif
   m_cTEncTop.setDecodingRefreshType          ( m_iDecodingRefreshType );
   m_cTEncTop.setGOPSize                      ( m_iGOPSize );
@@ -1358,15 +1354,8 @@
   Int maxViewId = xGetMax( m_viewId ); 
 
-#if H_MV_6_PS_O0109_22
   Int viewIdLen = gCeilLog2( maxViewId + 1 ); 
   const Int maxViewIdLen = ( 1 << 4 ) - 1; 
   assert( viewIdLen <= maxViewIdLen ); 
   vps.setViewIdLen( viewIdLen ); 
-#else
-  Int viewIdLenMinus1 = std::max( gCeilLog2( maxViewId + 1 ) - 1, 0 ) ; 
-  const Int maxViewIdLenMinus1 = ( 1 << 4 ) - 1; 
-  assert( viewIdLenMinus1 <= maxViewIdLenMinus1  ); 
-  vps.setViewIdLenMinus1( viewIdLenMinus1 ); 
-#endif
   for (Int i = 0; i < m_iNumberOfViews; i++)
   {
@@ -1389,8 +1378,6 @@
     }
 
-#if H_MV_6_PS_O0096_21
   Int  defaultDirectDependencyType = -1; 
   Bool defaultDirectDependencyFlag = true; 
-#endif
   for( Int depLayer = 1; depLayer < m_numberOfLayers; depLayer++ )
   {
@@ -1401,5 +1388,4 @@
       Int refLayer = m_directRefLayers[depLayer][i]; 
       vps.setDirectDependencyFlag( depLayer, refLayer, true); 
-#if H_MV_6_PS_O0096_21
       Int curDirectDependencyType = m_dependencyTypes[depLayer][i]; 
 
@@ -1414,16 +1400,10 @@
       
       vps.setDirectDependencyType( depLayer, refLayer, curDirectDependencyType);       
-#else
-      vps.setDirectDependencyType( depLayer, refLayer,m_dependencyTypes[depLayer][i]); 
-#endif
-    }
-  }
-
-#if H_MV_6_PS_O0096_21
+    }
+  }
+
   vps.setDefaultDirectDependencyFlag( defaultDirectDependencyFlag );       
   vps.setDefaultDirectDependencyType( defaultDirectDependencyFlag ? defaultDirectDependencyType : -1 );       
-#endif
-
-#if H_MV_6_ILDSD_O0120_26
+
   // Max sub layers, + presence flag
   Bool subLayersMaxMinus1PresentFlag = false; 
@@ -1450,5 +1430,4 @@
 
   vps.setVpsSubLayersMaxMinus1PresentFlag( subLayersMaxMinus1PresentFlag ); 
-#endif
 
 
@@ -1457,12 +1436,7 @@
   for ( Int refLayerIdInVps = 0; refLayerIdInVps < m_numberOfLayers; refLayerIdInVps++)
     {
-#if !H_MV_6_ILDDS_O0225_30
-    Int maxTid = -1; 
-#endif
     for ( Int curLayerIdInVps = 1; curLayerIdInVps < m_numberOfLayers; curLayerIdInVps++)
       {
-#if H_MV_6_ILDDS_O0225_30
       Int maxTid = -1; 
-#endif
       for( Int i = 0; i < getGOPSize(); i++ ) 
       {        
@@ -1478,13 +1452,7 @@
         }
       }
-#if H_MV_6_ILDDS_O0225_30    
       vps.setMaxTidIlRefPicsPlus1( refLayerIdInVps, curLayerIdInVps, maxTid + 1 );
       maxTidRefPresentFlag = maxTidRefPresentFlag || ( maxTid != 6 );    
     }
-#else
-    }
-    vps.setMaxTidIlRefPicPlus1( refLayerIdInVps, maxTid + 1 );
-    maxTidRefPresentFlag = maxTidRefPresentFlag || ( maxTid != 6 );    
-#endif
   }
 
@@ -1504,5 +1472,4 @@
   
   // Poc Lsb Not Present Flag
-#if H_MV_6_MISC_O0062_31
   for ( Int layerIdInVps = 1; layerIdInVps < m_numberOfLayers; layerIdInVps++)
   {
@@ -1512,5 +1479,4 @@
     }
   }
-#endif
   
   // All Ref layers active flag
@@ -1521,5 +1487,4 @@
     {        
       GOPEntry ge =  m_GOPListMvc[layerIdInVps][ ( i < getGOPSize()  ? i : MAX_GOP ) ]; 
-#if H_MV_6_ILDDS_ILREFPICS_27_34
       Int tId = ge.m_temporalId;  // Should be equal for all layers. 
       
@@ -1557,7 +1522,4 @@
       }
       assert ( maxTidIlRefAndSubLayerMaxVaildFlag ); // Something wrong with MaxTidIlRefPicsPlus1 or SubLayersVpsMaxMinus1
-#else
-      allRefLayersActiveFlag = allRefLayersActiveFlag && (ge.m_numActiveRefLayerPics == m_directRefLayers[ layerIdInVps ].size() ); 
-#endif
     }            
   }
@@ -1565,8 +1527,4 @@
   vps.setAllRefLayersActiveFlag( allRefLayersActiveFlag );
 
-#if !H_MV_6_PS_O0223_29
-  // Currently cross layer irap aligned is always true.   
-  vps.setCrossLayerIrapAlignedFlag( true ); 
-#endif
   vps.setRefLayers(); 
 }; 
@@ -1638,7 +1596,5 @@
   repFormat->setPicHeightVpsInLumaSamples ( m_iSourceHeight );
   repFormat->setPicWidthVpsInLumaSamples  ( m_iSourceWidth  );    
-#if H_MV_6_PS_REP_FORM_18_19_20
   repFormat->setChromaAndBitDepthVpsPresentFlag( true );    
-#endif
   // ToDo not supported yet. 
   //repFormat->setSeparateColourPlaneVpsFlag( );
@@ -1653,5 +1609,4 @@
 }
 
-#if H_MV_6_HRD_O0217_13
 Void TAppEncTop::xSetDpbSize                ( TComVPS& vps )
 {
@@ -1709,5 +1664,4 @@
   }  
 }
-#endif
 
 
@@ -1729,15 +1683,9 @@
     } 
   }
-#if H_MV_6_HRD_O0217_13
   vps.deriveLayerSetLayerIdList(); 
-#endif
 
   Int numAddOuputLayerSets = (Int) m_outputLayerSetIdx.size(); 
   // Additional output layer sets + profileLevelTierIdx
-#if H_MV_6_PS_0109_25
   vps.setDefaultOneTargetOutputLayerIdc   ( m_defaultOneTargetOutputLayerIdc ); 
-#else
-  vps.setDefaultOneTargetOutputLayerFlag   ( m_defaultOneTargetOutputLayerFlag ); 
-#endif
   vps.setMoreOutputLayerSetsThanDefaultFlag( numAddOuputLayerSets       != 0 );   
   vps.setNumAddOutputLayerSetsMinus1       ( numAddOuputLayerSets - 1        ); 
@@ -1745,5 +1693,4 @@
 
 
-#if H_MV_6_HRD_O0217_13
   for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++)
   {
@@ -1760,10 +1707,4 @@
     }
   }
-#else
-  for (Int lsIdx = 1; lsIdx < m_vpsNumLayerSets; lsIdx++)
-  {
-    vps.setProfileLevelTierIdx( lsIdx, m_profileLevelTierIdx[ lsIdx ] ); 
-  }
-#endif
 
   for (Int addOutLs = 0; addOutLs < numAddOuputLayerSets; addOutLs++ )
@@ -1788,7 +1729,5 @@
     }
   }
-#if H_MV_6_HRD_O0217_13
   vps.deriveTargetLayerIdLists(); 
-#endif
 }
 
@@ -1807,8 +1746,6 @@
     // however preliminary setting it from input parameters
 
-#if H_MV_6_PS_O0223_29
     pcVPSVUI->setCrossLayerPicTypeAlignedFlag( m_crossLayerPicTypeAlignedFlag );
     pcVPSVUI->setCrossLayerIrapAlignedFlag   ( m_crossLayerIrapAlignedFlag    );
-#endif
 
     pcVPSVUI->setBitRatePresentVpsFlag( m_bitRatePresentVpsFlag );
@@ -1849,5 +1786,4 @@
     }
 
-#if H_MV_6_O0226_37
     pcVPSVUI->setTilesNotInUseFlag( m_tilesNotInUseFlag );
 
@@ -1885,16 +1821,4 @@
       }
     }
-#else
-    for( Int i = 1; i  <=  vps.getMaxLayersMinus1(); i++ )
-    {
-      for( Int  j = 0; j < vps.getNumDirectRefLayers( vps.getLayerIdInNuh( i ) ); j++ ) 
-      {
-        if ( m_tileBoundariesAlignedFlag[i].size() > j )
-        {
-          pcVPSVUI->setTileBoundariesAlignedFlag( i, j, m_tileBoundariesAlignedFlag[i][j]);
-        }
-      }
-    }
-#endif
 
     pcVPSVUI->setIlpRestrictedRefLayersFlag( m_ilpRestrictedRefLayersFlag );
@@ -1927,5 +1851,4 @@
       }
     }      
-#if H_MV_6_PS_O0118_33
     pcVPSVUI->setVideoSignalInfoIdxPresentFlag( true ); 
     pcVPSVUI->setVpsNumVideoSignalInfoMinus1  ( 0    ); 
@@ -1947,8 +1870,5 @@
       pcVPSVUI->setVpsVideoSignalInfoIdx( i, 0 ); 
     }
-#endif
-#if H_MV_6_HRD_O0164_15
     pcVPSVUI->setVpsVuiBspHrdPresentFlag( false ); // TBD
-#endif
   }
 }
@@ -1985,9 +1905,5 @@
     if( vps.getUseDLTFlag( layer ) )
     {
-#if H_MV_LAYER_WISE_STARTUP
       xAnalyzeInputBaseDepth(layer, max(  m_iIntraPeriod[layer], 24), &vps);
-#else
-      xAnalyzeInputBaseDepth(layer, max(m_iIntraPeriod, 24), &vps);
-#endif
     }
 #endif
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.h	(revision 765)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.h	(revision 766)
@@ -129,7 +129,5 @@
   Void xSetProfileTierLevel       ( TComVPS& vps );
   Void xSetRepFormat              ( TComVPS& vps );
-#if H_MV_6_HRD_O0217_13
   Void xSetDpbSize                ( TComVPS& vps );
-#endif
   Void xSetVPSVUI                 ( TComVPS& vps );
   GOPEntry* xGetGopEntry( Int layerIdInVps, Int poc );