Index: branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 767)
+++ branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 768)
@@ -124,5 +124,7 @@
   if ( !cfg_TargetDecLayerIdSetFile.empty() )
   {
+#if H_MV
     m_targetDecLayerIdSetFileEmpty = false;     
+#endif
     FILE* targetDecLayerIdSetFile = fopen ( cfg_TargetDecLayerIdSetFile.c_str(), "r" );
     if ( targetDecLayerIdSetFile )
Index: branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.h	(revision 767)
+++ branches/HTM-9.2-dev0/source/App/TAppDecoder/TAppDecCfg.h	(revision 768)
@@ -75,5 +75,7 @@
 
   std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
+#if H_MV
   Bool          m_targetDecLayerIdSetFileEmpty;      ///< indication if target layers are given by file
+#endif
   Int           m_respectDefDispWindow;               ///< Only output content inside the default display window 
 
@@ -84,6 +86,4 @@
   TAppDecCfg()
   : m_pchBitstreamFile(NULL)
-#if H_MV
-#endif
   , m_pchReconFile(NULL)
   , m_iSkipFrame(0)
@@ -92,5 +92,7 @@
   , m_iMaxTemporalLayer(-1)
   , m_decodedPictureHashSEIEnabled(0)
+#if H_MV
   , m_targetDecLayerIdSetFileEmpty(true)
+#endif
   , m_respectDefDispWindow(0)
   {}
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 767)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 768)
@@ -444,7 +444,10 @@
   ("QuadtreeTUMaxDepthIntra", m_uiQuadtreeTUMaxDepthIntra, 1u, "Depth of TU tree for intra CUs")
   ("QuadtreeTUMaxDepthInter", m_uiQuadtreeTUMaxDepthInter, 2u, "Depth of TU tree for inter CUs")
-  
   // Coding structure parameters
+#if H_MV  
   ("IntraPeriod,-ip",         m_iIntraPeriod,std::vector<Int>(1,-1), "Intra period in frames, (-1: only first frame), per layer")
+#else
+("IntraPeriod,-ip",         m_iIntraPeriod,              -1, "Intra period in frames, (-1: only first frame)")
+#endif
   ("DecodingRefreshType,-dr", m_iDecodingRefreshType,       0, "Intra refresh type (0:none 1:CRA 2:IDR)")
   ("GOPSize,g",               m_iGOPSize,                   1, "GOP size of temporal structure")
@@ -1440,8 +1443,12 @@
   xConfirmPara( m_iGOPSize < 1 ,                                                            "GOP Size must be greater or equal to 1" );
   xConfirmPara( m_iGOPSize > 1 &&  m_iGOPSize % 2,                                          "GOP Size must be a multiple of 2, if GOP Size is greater than 1" );
+#if H_MV
   for( Int layer = 0; layer < m_numberOfLayers; layer++ )
   {
     xConfirmPara( (m_iIntraPeriod[layer] > 0 && m_iIntraPeriod[layer] < m_iGOPSize) || m_iIntraPeriod[layer] == 0, "Intra period must be more than GOP size, or -1 , not 0" );
   }
+#else
+  xConfirmPara( (m_iIntraPeriod > 0 && m_iIntraPeriod < m_iGOPSize) || m_iIntraPeriod == 0, "Intra period must be more than GOP size, or -1 , not 0" );
+#endif
   xConfirmPara( m_iDecodingRefreshType < 0 || m_iDecodingRefreshType > 2,                   "Decoding Refresh Type must be equal to 0, 1 or 2" );
 #if H_MV
@@ -1469,8 +1476,12 @@
   if (m_iDecodingRefreshType == 2)
   {
+#if H_MV
     for (Int i = 0; i < m_numberOfLayers; i++ )
     {
       xConfirmPara( m_iIntraPeriod[i] > 0 && m_iIntraPeriod[i] <= m_iGOPSize ,                      "Intra period must be larger than GOP size for periodic IDR pictures");
     }
+#else
+    xConfirmPara( m_iIntraPeriod > 0 && m_iIntraPeriod <= m_iGOPSize ,                      "Intra period must be larger than GOP size for periodic IDR pictures");
+#endif
   }
   xConfirmPara( (m_uiMaxCUWidth  >> m_uiMaxCUDepth) < 4,                                    "Minimum partition width size should be larger than or equal to 8");
@@ -1731,5 +1742,10 @@
   /* if this is an intra-only sequence, ie IntraPeriod=1, don't verify the GOP structure
    * This permits the ability to omit a GOP structure specification */
-  if (m_iIntraPeriod[layer] == 1 && m_GOPList[0].m_POC == -1) {
+#if H_MV
+  if (m_iIntraPeriod[layer] == 1 && m_GOPList[0].m_POC == -1)
+  {
+#else
+  if (m_iIntraPeriod == 1 && m_GOPList[0].m_POC == -1) {
+#endif
     m_GOPList[0] = GOPEntry();
     m_GOPList[0].m_QPFactor = 1;
@@ -1756,5 +1772,9 @@
   }
   Int numOK=0;
+#if H_MV
+xConfirmPara( m_iIntraPeriod >=0&&(m_iIntraPeriod%m_iGOPSize!=0), "Intra period must be a multiple of GOPSize, or -1" );
+#else
   xConfirmPara( m_iIntraPeriod[layer] >=0&&(m_iIntraPeriod[layer]%m_iGOPSize!=0), "Intra period must be a multiple of GOPSize, or -1" ); 
+#endif
 
   for(Int i=0; i<m_iGOPSize; i++)
@@ -2292,5 +2312,9 @@
   printf("Min PCM size                 : %d\n", 1 << m_uiPCMLog2MinSize);
   printf("Motion search range          : %d\n", m_iSearchRange );
+#if H_MV
   xPrintParaVector( "Intra period", m_iIntraPeriod );
+#else
+  printf("Intra period                 : %d\n", m_iIntraPeriod );
+#endif
   printf("Decoding refresh type        : %d\n", m_iDecodingRefreshType );
 #if !H_MV
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 767)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 768)
@@ -178,5 +178,9 @@
   
   // coding structure
+#if H_MV
   std::vector<Int> m_iIntraPeriod;                            ///< period of I-slice (random access period)
+#else
+  Int       m_iIntraPeriod;                                   ///< period of I-slice (random access period)
+#endif
   Int       m_iDecodingRefreshType;                           ///< random access type
   Int       m_iGOPSize;                                       ///< GOP size of hierarchical structure
Index: branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 767)
+++ branches/HTM-9.2-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 768)
@@ -230,5 +230,9 @@
   
   //====== Coding Structure ========
+#if H_MV
   m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod[ layerIdInVps ] );
+#else
+  m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod );
+#endif
   m_cTEncTop.setDecodingRefreshType          ( m_iDecodingRefreshType );
   m_cTEncTop.setGOPSize                      ( m_iGOPSize );
Index: branches/HTM-9.2-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 767)
+++ branches/HTM-9.2-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 768)
@@ -3753,3 +3753,24 @@
   }
 }
-#endif
+
+Void TComVUI::inferVideoSignalInfo( TComVPS* vps, Int layerIdCurr )
+{
+  if ( layerIdCurr == 0 || !vps->getVpsVuiPresentFlag() ) 
+  {
+    return; 
+  }
+
+  TComVPSVUI* vpsVUI = vps->getVPSVUI(); 
+  assert( vpsVUI != NULL );  
+
+  TComVideoSignalInfo* videoSignalInfo = vpsVUI->getVideoSignalInfo( vpsVUI->getVpsVideoSignalInfoIdx( vps->getLayerIdInVps( layerIdCurr ) ) ); 
+  assert( videoSignalInfo != NULL );
+
+  setVideoFormat            ( videoSignalInfo->getVideoVpsFormat            () ); 
+  setVideoFullRangeFlag     ( videoSignalInfo->getVideoFullRangeVpsFlag     () );
+  setColourPrimaries        ( videoSignalInfo->getColourPrimariesVps        () );
+  setTransferCharacteristics( videoSignalInfo->getTransferCharacteristicsVps() );
+  setMatrixCoefficients     ( videoSignalInfo->getMatrixCoeffsVps           () );
+}
+#endif
+
Index: branches/HTM-9.2-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-9.2-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 767)
+++ branches/HTM-9.2-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 768)
@@ -617,5 +617,5 @@
   Int  getBitDepthVpsChromaMinus8(  ) { return m_bitDepthVpsChromaMinus8; } 
 };
-#endif
+
 
 class TComDpbSize
@@ -664,5 +664,5 @@
   Int  getMaxVpsLatencyIncreasePlus1( Int i, Int j ) { return m_maxVpsLatencyIncreasePlus1[i][j]; } 
 };
-
+#endif
 class TComVPS
 {
@@ -1352,24 +1352,7 @@
   TComHRD* getHrdParameters                 ()             { return &m_hrdParameters; }
   TimingInfo* getTimingInfo() { return &m_timingInfo; }
-
-  Void inferVideoSignalInfo( TComVPS* vps, Int layerIdCurr )
-  {
-    if ( layerIdCurr == 0 || !vps->getVpsVuiPresentFlag() ) 
-    {
-      return; 
-    }
-
-    TComVPSVUI* vpsVUI = vps->getVPSVUI(); 
-    assert( vpsVUI != NULL );  
-
-    TComVideoSignalInfo* videoSignalInfo = vpsVUI->getVideoSignalInfo( vpsVUI->getVpsVideoSignalInfoIdx( vps->getLayerIdInVps( layerIdCurr ) ) ); 
-    assert( videoSignalInfo != NULL );
-
-    setVideoFormat            ( videoSignalInfo->getVideoVpsFormat            () ); 
-    setVideoFullRangeFlag     ( videoSignalInfo->getVideoFullRangeVpsFlag     () );
-    setColourPrimaries        ( videoSignalInfo->getColourPrimariesVps        () );
-    setTransferCharacteristics( videoSignalInfo->getTransferCharacteristicsVps() );
-    setMatrixCoefficients     ( videoSignalInfo->getMatrixCoeffsVps           () );     
-  }
+#if H_MV
+  Void inferVideoSignalInfo( TComVPS* vps, Int layerIdCurr );
+#endif
 };
 
Index: branches/HTM-9.2-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-9.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 767)
+++ branches/HTM-9.2-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 768)
@@ -55,5 +55,5 @@
 
 #ifndef HEVC_EXT
-#define HEVC_EXT                    2
+#define HEVC_EXT                    0
 #endif
 
Index: branches/HTM-9.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 767)
+++ branches/HTM-9.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 768)
@@ -557,6 +557,7 @@
 
   READ_FLAG(     uiCode, "video_signal_type_present_flag");           pcVUI->setVideoSignalTypePresentFlag(uiCode);
+#if H_MV
   assert( pcSPS->getLayerId() == 0 || !pcVUI->getVideoSignalTypePresentFlag() ); 
-
+#endif
   if (pcVUI->getVideoSignalTypePresentFlag())
   {
Index: branches/HTM-9.2-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/HTM-9.2-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 767)
+++ branches/HTM-9.2-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 768)
@@ -495,5 +495,7 @@
   }
   WRITE_FLAG(pcVUI->getVideoSignalTypePresentFlag(),            "video_signal_type_present_flag");
+#if H_MV
   assert( pcSPS->getLayerId() == 0 || !pcVUI->getVideoSignalTypePresentFlag() ); 
+#endif
   if (pcVUI->getVideoSignalTypePresentFlag())
   {
@@ -1657,5 +1659,5 @@
     // if( separate_colour_plane_flag  ==  1 )
     //   colour_plane_id                                      u(2)
-
+#if H_MV
     if ( (pcSlice->getLayerId() > 0 && !vps->getPocLsbNotPresentFlag( pcSlice->getLayerIdInVps())) || !pcSlice->getIdrPicFlag() )
     {
@@ -1663,4 +1665,5 @@
       WRITE_CODE( picOrderCntLSB, pcSlice->getSPS()->getBitsForPOC(), "slice_pic_order_cnt_lsb");
     }
+#endif
     if( !pcSlice->getIdrPicFlag() )
     {