Index: trunk/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 738)
+++ trunk/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 773)
@@ -85,9 +85,5 @@
   ("OutputBitDepthC,d", m_outputBitDepthC, 0, "bit depth of YUV output chroma component (default: use 0 for native depth)")
 #if H_MV
-#if H_MV_6_HRD_O0217_13
   ("TargetOptLayerSetIdx,x", m_targetOptLayerSetIdx, -1, "Target output layer set index. (default: -1, determine automatically to be equal to highest layer set index") // Should actually equal to 0 as default. However, this would cause only the base layer to be decoded.  
-#else
-  ("MaxLayerId,-ls", m_maxLayerId, MAX_NUM_LAYER_IDS-1, "Maximum LayerId to be decoded.")
-#endif
 #endif
   ("MaxTemporalLayer,t", m_iMaxTemporalLayer, -1, "Maximum Temporal Layer to be decoded. -1 to decode all layers")
@@ -128,5 +124,5 @@
   if ( !cfg_TargetDecLayerIdSetFile.empty() )
   {
-#if H_MV_6_HRD_O0217_13
+#if H_MV
     m_targetDecLayerIdSetFileEmpty = false;     
 #endif
@@ -174,15 +170,5 @@
   }
 #if H_MV
-#if H_MV_6_HRD_O0217_13
   m_targetDecLayerIdSet.push_back( 0 );         // Only base layer at startup
-#else
-  else
-  {
-    for ( Int curLayerId = 0; curLayerId <= m_maxLayerId; curLayerId++ )
-    {
-      m_targetDecLayerIdSet.push_back( curLayerId );
-    }
-  }
-#endif
 #endif
 
Index: trunk/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecCfg.h	(revision 738)
+++ trunk/source/App/TAppDecoder/TAppDecCfg.h	(revision 773)
@@ -59,7 +59,5 @@
   Char*         m_pchBitstreamFile;                   ///< input bitstream file name
 #if H_MV
-#if H_MV_6_HRD_O0217_13
   Int           m_targetOptLayerSetIdx;               ///< target output layer set index
-#endif
   Int           m_maxLayerId;                         ///< maximum nuh_layer_id decoded
   std::vector<Char*> m_pchReconFiles;                 ///< array of output reconstruction file name create from output reconstruction file name
@@ -77,5 +75,5 @@
 
   std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
-#if H_MV_6_HRD_O0217_13
+#if H_MV
   Bool          m_targetDecLayerIdSetFileEmpty;      ///< indication if target layers are given by file
 #endif
@@ -88,9 +86,4 @@
   TAppDecCfg()
   : m_pchBitstreamFile(NULL)
-#if H_MV
-#if !H_MV_6_HRD_O0217_13
-  , m_maxLayerId(0)
-#endif
-#endif
   , m_pchReconFile(NULL)
   , m_iSkipFrame(0)
@@ -99,5 +92,5 @@
   , m_iMaxTemporalLayer(-1)
   , m_decodedPictureHashSEIEnabled(0)
-#if H_MV_6_HRD_O0217_13
+#if H_MV
   , m_targetDecLayerIdSetFileEmpty(true)
 #endif
Index: trunk/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 738)
+++ trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 773)
@@ -61,5 +61,4 @@
 {
 #if H_MV
-#if H_MV_LAYER_WISE_STARTUP
   for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++) 
   {
@@ -67,7 +66,4 @@
     m_layerInitilizedFlags[i] = false; 
   }
-#else
-  for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++) m_layerIdToDecIdx[i] = -1; 
-#endif
 #endif
 #if H_3D
@@ -192,7 +188,5 @@
     Bool newSliceDiffPoc   = false;
     Bool newSliceDiffLayer = false;
-#if H_MV_FIX_SKIP_PICTURES
     Bool sliceSkippedFlag = false; 
-#endif
 #if H_3D
     Bool allLayersDecoded  = false;     
@@ -212,32 +206,17 @@
       read(nalu, nalUnit);
 #if H_MV      
-#if !H_MV_6_HRD_O0217_13
-      Int decIdx     = xGetDecoderIdx( nalu.m_layerId , true );
-#endif
-#if H_MV_6_LAYER_ID_32
       if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu) || nalu.m_layerId > MAX_NUM_LAYER_IDS-1 ) 
-#else            
-      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu) )
-#endif
       {
         bNewPicture = false;
-#if H_MV_6_LAYER_ID_32
         if ( !bitstreamFile )
         {
           decIdxLastPic     = decIdxCurrPic; 
         }
-#endif
       }
       else
       { 
-#if H_MV_6_HRD_O0217_13
         Int decIdx     = xGetDecoderIdx( nalu.m_layerId , true );      
-#endif
         newSliceDiffLayer = nalu.isSlice() && ( nalu.m_layerId != layerIdCurrPic ) && !firstSlice;
-#if H_MV_FIX_SKIP_PICTURES
         newSliceDiffPoc   = m_tDecTop[decIdx]->decode(nalu, m_iSkipFrame, m_pocLastDisplay[decIdx], newSliceDiffLayer, sliceSkippedFlag );
-#else
-        newSliceDiffPoc   = m_tDecTop[decIdx]->decode(nalu, m_iSkipFrame, m_pocLastDisplay[decIdx], newSliceDiffLayer );
-#endif
         // decode function only returns true when all of the following conditions are true
         // - poc in particular layer changes
@@ -245,5 +224,4 @@
         // - nalu.isSlice() == true      
 
-#if H_MV_6_HRD_O0217_13
         // Update TargetDecLayerIdList only when not specified by layer id file, specification by file might actually out of conformance. 
         if (nalu.m_nalUnitType == NAL_UNIT_VPS && m_targetDecLayerIdSetFileEmpty )
@@ -258,13 +236,6 @@
           m_targetDecLayerIdSet = vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
         }
-#endif
-#if H_MV_FIX_SKIP_PICTURES
         bNewPicture       = ( newSliceDiffLayer || newSliceDiffPoc ) && !sliceSkippedFlag; 
         if ( nalu.isSlice() && firstSlice && !sliceSkippedFlag )        
-#else
-        bNewPicture       = newSliceDiffLayer || newSliceDiffPoc; 
-
-        if ( nalu.isSlice() && firstSlice )
-#endif
         {
           layerIdCurrPic = nalu.m_layerId; 
@@ -881,10 +852,8 @@
   Int decIdx = -1; 
 
-#if H_MV_6_LAYER_ID_32
   if ( layerId > MAX_NUM_LAYER_IDS-1 )  
   {
     return decIdx; 
   }
-#endif
 
   if ( m_layerIdToDecIdx[ layerId ] != -1 ) 
@@ -906,7 +875,5 @@
     m_tDecTop[ decIdx ]->setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
     m_tDecTop[ decIdx ]->setIvPicLists( &m_ivPicLists ); 
-#if H_MV_LAYER_WISE_STARTUP
     m_tDecTop[ decIdx ]->setLayerInitilizedFlags( m_layerInitilizedFlags );
-#endif
 
 #if H_3D
Index: trunk/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.h	(revision 738)
+++ trunk/source/App/TAppDecoder/TAppDecTop.h	(revision 773)
@@ -67,7 +67,5 @@
   Int                             m_numDecoders;                               ///< number of decoder instances
   TComPicLists                    m_ivPicLists;                                ///< picture buffers of decoder instances
-#if H_MV_LAYER_WISE_STARTUP
   Bool                            m_layerInitilizedFlags[ MAX_NUM_LAYER_IDS ]; ///< for layerwise startup 
-#endif
 
 #else